
QGIS Application - Bug report #18286

cannot filter by $geometry, $length, $area etc.

2018-03-01 11:52 AM - Mattias Spangmyr

Status: Closed

Priority: High

Assignee: Hugo Mercier

Category: Attribute table

Affected QGIS version:3.3(master) Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 26177

Description

The "Advanced Filter (Expression)" function of the Attribute Table does not seem to be able to filter by comparing the current feature's

geometry ($geometry) to NULL.

Applying either of the following expressions filters nothing:

    -  $geometry IS NULL

    -  $geometry IS NOT NULL

Both of the above expressions work when using "Select features using an expression", so its still possible to find null geometries that way.

Associated revisions

Revision d9a10280 - 2018-10-24 10:12 AM - Hugo Mercier

Attribute table filter: force geometry extraction when needed

Fixes #18286

History

#1 - 2018-03-01 11:54 AM - Giovanni Manghi

- Status changed from Open to Feedback

What about QGIS 3?

#2 - 2018-03-02 01:10 PM - Mattias Spangmyr

- Status changed from Feedback to Open

Giovanni Manghi wrote:

What about QGIS 3?

I tested in QGIS 3.0.0 just now and the behaviour is exactly the same as far as I can see. However, I need to revise my description as the expression

"$geometry IS NOT NULL" actually does filter, only it does not show any features either with or without geometry.

My version (on Win 7 64-bit):
QGIS version              3.0.0-Girona     QGIS code revision       001c80b0c3

Compiled against Qt       5.9.2            Running against Qt       5.9.2

Compiled against GDAL/OGR 2.2.3            Running against GDAL/OGR 2.2.3

Compiled against GEOS     3.5.0-CAPI-1.9.0 Running against GEOS     3.5.0-CAPI-1.9.0 r4084

PostgreSQL Client Version 9.2.4            SpatiaLite Version       4.3.0

QWT Version               6.1.3            QScintilla2 Version      2.10.1

PROJ.4 Version            493

#3 - 2018-03-03 06:33 PM - Giovanni Manghi

- Subject changed from Advanced Filter (Expression) unable to filter by $geometry IS NULL to Advanced Filter (Expression) in attribute table unable to 

filter by $geometry IS NULL

- Affected QGIS version changed from 2.18.16 to 3.0.0

- Operating System deleted (Windows 7)

#4 - 2018-10-15 09:34 AM - Tudor Bărăscu

Just filling out a bug report when I noticed this one.

Filtering a line or polygon layer by $length or $area doesn't work:

Steps to reproduce:

- Open attribute table

- Select Advanced Filter (Expression)

- Create a simple expression: length bigger than 10 meters (for my case): $length > 10

- I noticed that in the Output preview window I get 0 or 1 (True or False) but in the attribute table all the rows dissapear (making the expression $length <=

10 does the same)

Tested on QGIS Master (3.3) and 2.18

@Giovanni Maybe the issue name should be changed to "cannot filter by $geometry, $length, $area  etc.

#5 - 2018-10-15 09:52 AM - Giovanni Manghi

- Subject changed from Advanced Filter (Expression) in attribute table unable to filter by $geometry IS NULL to cannot filter by $geometry, $length, 

$area etc.

- Affected QGIS version changed from 3.0.0 to 3.3(master)

#6 - 2018-10-22 01:38 PM - Tudor Bărăscu

- File atr_bug.jpg added

@Giovanni I think this issue should have a High priority as I discovered more problems (consequences) tied to it.

For example, any form constraints that use the geometry in any way work well in feature forms but are not working as expected in the attribute table.

I've attached a screenshot.

For the same feature, the "single" form passes the constraints whereas the same form in the attribute table doesn't so the editors are not guided well from

the attribute table.
#7 - 2018-10-22 07:33 PM - Giovanni Manghi

- Regression? changed from No to Yes

- Priority changed from Normal to High

Tudor Bărăscu wrote:

@Giovanni I think this issue should have a High priority as I discovered more problems (consequences) tied to it.

For example, any form constraints that use the geometry in any way work well in feature forms but are not working as expected in the attribute table.

I assume this is a regression(?).
#8 - 2018-10-24 09:18 AM - Hugo Mercier

- Assignee set to Hugo Mercier

Confirmed.

When tested with a shapefile, "$" fields do not work. However, when trying with a memory layer it works.

#9 - 2018-10-24 09:22 AM - Nyall Dawson

This is because attribute table doesn't fetch geometries (for performance reasons).

#10 - 2018-10-24 09:31 AM - Hugo Mercier

Hmmm, apparently the filter can fetch geometries when needed (this is what I observe with memory layers)

https://github.com/qgis/QGIS/blob/master/src/app/qgsattributetabledialog.cpp#L1106

#11 - 2018-10-24 10:16 AM - Hugo Mercier

- Pull Request or Patch supplied changed from No to Yes

- Status changed from Open to In Progress

PR https://github.com/qgis/QGIS/pull/8298

#12 - 2018-10-24 11:39 AM - Hugo Mercier

- Status changed from In Progress to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|d9a10280eb1d10f19457e845bda8b80d128d19c4.

Files

test.zip 1.47 KB 2018-03-01 Mattias Spangmyr

atr_bug.jpg 101 KB 2018-10-22 Tudor Bărăscu
